# parsedate2.ry: Written by Tadayoshi Funaba 1999-2001
# $Id: parsedate2.ry,v 1.9 2001-01-24 18:42:27+09 tadf Exp $
#
# parsedate2.tab.rb: generated by racc (runtime embedded)
#

###### racc/parser.rb

unless $".index 'racc/parser.rb' then
$".push 'racc/parser.rb'

type.module_eval <<'..end /usr/local/ruby-1.6/lib/ruby/site_ruby/1.6/racc/parser.rb modeval..id5e8feb761f', '/usr/local/ruby-1.6/lib/ruby/site_ruby/1.6/racc/parser.rb', 1
#
# parser.rb
#
#   Copyright (c) 1999-2001 Minero Aoki <aamine@dp.u-netsurf.ne.jp>
#
#   This program is free software.
#   You can distribute/modify this program under the terms of
#   the GNU Lesser General Public License version 2 or later.
#
#   As a special exception, when this code is copied by Racc
#   into a Racc output file, you may use that output file
#   without restriction.
#

module Racc
  class ParseError < StandardError; end
end
unless defined? ParseError then
  ParseError = Racc::ParseError
end


module Racc

  class Parser

    private


    begin
      if defined? Racc_Debug_Ruby_Parser then
        raise LoadError, 'debug ruby routine'
      end
      require 'racc/cparse'
      unless new.respond_to? :_racc_do_parse_c, true then
        raise LoadError, 'old cparse.so'
      end
      Racc_Main_Parsing_Routine = :_racc_do_parse_c
      Racc_YY_Parse_Method      = :_racc_yyparse_c
    rescue LoadError
      Racc_Main_Parsing_Routine = :_racc_do_parse_rb
      Racc_YY_Parse_Method      = :_racc_yyparse_rb
    end

    Racc_ruby_parser_version = '1.3.8'
    Racc_parser_version = Racc_ruby_parser_version

    def self.racc_runtime_type
      if Racc_Main_Parsing_Routine == :_racc_do_parse_c then
        'c'
      else
        'ruby'
      end
    end


    def _racc_setup
      t = self.type

      unless t::Racc_debug_parser then
        @yydebug = false
      end
      @yydebug = false unless defined? @yydebug

      if @yydebug then
        @racc_debug_out = $stderr unless defined? @racc_debug_out
        @racc_debug_out ||= $stderr
      end

      arg = t::Racc_arg
      if arg.size < 14 then
        arg[13] = true
      end
      arg
    end

    def _racc_init_sysvars
      @racc_state = [ 0 ]
      @racc_tstack = []
      @racc_vstack = []

      @racc_t = nil
      @racc_val = nil

      @racc_read_next = true

      @racc_user_yyerror = false
      @racc_error_status = 0
    end


    ###
    ### do_parse
    ###

    def do_parse
      __send__ Racc_Main_Parsing_Routine, _racc_setup(), false
    end

    def next_token
      raise NotImplementError, "#{self.type}\#next_token must be defined"
    end

    def _racc_do_parse_rb( arg, in_debug )
      action_table, action_check, action_default, action_pointer,
      goto_table,   goto_check,   goto_default,   goto_pointer,
      nt_base,      reduce_table, token_table,    shift_n,
      reduce_n,     use_result    = arg

      _racc_init_sysvars
      tok = act = i = nil
      nerr = 0


      catch( :racc_end_parse ) {
      while true do

        if i = action_pointer[ @racc_state[-1] ] then
          if @racc_read_next then
            if @racc_t != 0 then   # not EOF
              tok, @racc_val = next_token()
              unless tok then   # EOF
                @racc_t = 0
              else
                @racc_t = (token_table[tok] or 1)   # error token
              end
              racc_read_token( @racc_t, tok, @racc_val ) if @yydebug

              @racc_read_next = false
            end
          end
          i += @racc_t
          if i >= 0 and act = action_table[i] and
             action_check[i] == @racc_state[-1] then
            ;
          else
            act = action_default[ @racc_state[-1] ]
          end
        else
          act = action_default[ @racc_state[-1] ]
        end

        while act = _racc_evalact( act, arg ) do end

      end
      }
    end


    ###
    ### yyparse
    ###

    def yyparse( recv, mid )
      __send__ Racc_YY_Parse_Method, recv, mid, _racc_setup(), true
    end

    def _racc_yyparse_rb( recv, mid, arg, c_debug )
      action_table, action_check, action_default, action_pointer,
      goto_table,   goto_check,   goto_default,   goto_pointer,
      nt_base,      reduce_table, token_table,    shift_n,
      reduce_n,     use_result,   = arg

      _racc_init_sysvars
      tok = nil
      act = nil
      i = nil
      nerr = 0


      catch( :racc_end_parse ) {
        until i = action_pointer[ @racc_state[-1] ] do
          while act = _racc_evalact(
                  action_default[ @racc_state[-1] ], arg ) do end
        end

        recv.__send__( mid ) do |tok, val|
# $stderr.puts "rd: tok=#{tok}, val=#{val}"
          unless tok then
            @racc_t = 0
          else
            @racc_t = (token_table[tok] or 1)   # error token
          end
          @racc_val = val
          @racc_read_next = false

          i += @racc_t
          if i >= 0 and act = action_table[i] and
             action_check[i] == @racc_state[-1] then
# $stderr.puts "01: act=#{act}"
          else
            act = action_default[ @racc_state[-1] ]
# $stderr.puts "02: act=#{act}"
# $stderr.puts "curstate=#{@racc_state[-1]}"
          end

          while act = _racc_evalact( act, arg ) do end

          while not (i = action_pointer[ @racc_state[-1] ]) or
                not @racc_read_next or
                @racc_t == 0 do   # $
            if i and i += @racc_t and
               i >= 0 and
               act = action_table[i] and
               action_check[i] == @racc_state[-1] then
# $stderr.puts "03: act=#{act}"
              ;
            else
# $stderr.puts "04: act=#{act}"
              act = action_default[ @racc_state[-1] ]
            end

            while act = _racc_evalact( act, arg ) do end
          end
        end
      }
    end


    ###
    ### common
    ###

    def _racc_evalact( act, arg )
# $stderr.puts "ea: act=#{act}"
      action_table, action_check, action_default, action_pointer,
      goto_table,   goto_check,   goto_default,   goto_pointer,
      nt_base,      reduce_table, token_table,    shift_n,
      reduce_n,     use_result,   = arg
nerr = 0   # tmp

      if act > 0 and act < shift_n then
        #
        # shift
        #

        if @racc_error_status > 0 then
          @racc_error_status -= 1 unless @racc_t == 1   # error token
        end

        @racc_vstack.push @racc_val
        @racc_state.push act
        @racc_read_next = true

        if @yydebug then
          @racc_tstack.push @racc_t
          racc_shift( @racc_t, @racc_tstack, @racc_vstack )
        end

      elsif act < 0 and act > -reduce_n then
        #
        # reduce
        #

        code = catch( :racc_jump ) {
          @racc_state.push _racc_do_reduce( arg, act )
          false
        }
        if code then
          case code
          when 1 # yyerror
            @racc_user_yyerror = true   # user_yyerror
            return -reduce_n
          when 2 # yyaccept
            return shift_n
          else
            raise RuntimeError, '[Racc Bug] unknown jump code'
          end
        end

      elsif act == shift_n then
        #
        # accept
        #

        racc_accept if @yydebug
        throw :racc_end_parse, @racc_vstack[0]

      elsif act == -reduce_n then
        #
        # error
        #

        case @racc_error_status
        when 0
          unless arg[21] then   # user_yyerror
            nerr += 1
            on_error @racc_t, @racc_val, @racc_vstack
          end
        when 3
          if @racc_t == 0 then   # is $
            throw :racc_end_parse, nil
          end
          @racc_read_next = true
        end
        @racc_user_yyerror = false
        @racc_error_status = 3

        while true do
          if i = action_pointer[ @racc_state[-1] ] then
            i += 1   # error token
            if i >= 0 and
               (act = action_table[i]) and
               action_check[i] == @racc_state[-1]  then
               break
            end
          end

          throw :racc_end_parse, nil if @racc_state.size < 2
          @racc_state.pop
          @racc_vstack.pop
          if @yydebug then
            @racc_tstack.pop
            racc_e_pop( @racc_state, @racc_tstack, @racc_vstack )
          end
        end

        return act

      else
        raise RuntimeError, "[Racc Bug] unknown action #{act.inspect}"
      end

      racc_next_state( @racc_state[-1], @racc_state ) if @yydebug

      nil
    end

    def _racc_do_reduce( arg, act )
      action_table, action_check, action_default, action_pointer,
      goto_table,   goto_check,   goto_default,   goto_pointer,
      nt_base,      reduce_table, token_table,    shift_n,
      reduce_n,     use_result,   = arg
      state = @racc_state
      vstack = @racc_vstack
      tstack = @racc_tstack

      i = act * -3
      len       = reduce_table[i]
      reduce_to = reduce_table[i+1]
      method_id = reduce_table[i+2]
      void_array = []

      tmp_t = tstack[ -len, len ] if @yydebug
      tmp_v = vstack[ -len, len ]
      tstack[ -len, len ] = void_array if @yydebug
      vstack[ -len, len ] = void_array
      state[ -len, len ]  = void_array

      # tstack must be updated AFTER method call
      if use_result then
        vstack.push __send__(method_id, tmp_v, vstack, tmp_v[0])
      else
        vstack.push __send__(method_id, tmp_v, vstack)
      end
      tstack.push reduce_to

      racc_reduce( tmp_t, reduce_to, tstack, vstack ) if @yydebug

      k1 = reduce_to - nt_base
      if i = goto_pointer[ k1 ] then
        i += state[-1]
        if i >= 0 and (curstate = goto_table[i]) and goto_check[i] == k1 then
          return curstate
        end
      end
      goto_default[ k1 ]
    end

    def on_error( t, val, vstack )
      raise ParseError, sprintf("\nparse error on value %s (%s)",
                                val.inspect,
                                token_to_str(t) || '?')
    end

    def yyerror
      throw :racc_jump, 1
    end

    def yyaccept
      throw :racc_jump, 2
    end

    def yyerrok
      @racc_error_status = 0
    end


    # for debugging output

    def racc_read_token( t, tok, val )
      @racc_debug_out.print 'read    '
      @racc_debug_out.print tok.inspect, '(', racc_token2str(t), ') '
      @racc_debug_out.puts val.inspect
      @racc_debug_out.puts
    end

    def racc_shift( tok, tstack, vstack )
      @racc_debug_out.puts "shift   #{racc_token2str tok}"
      racc_print_stacks tstack, vstack
      @racc_debug_out.puts
    end

    def racc_reduce( toks, sim, tstack, vstack )
      out = @racc_debug_out
      out.print 'reduce '
      if toks.empty? then
        out.print ' <none>'
      else
        toks.each {|t| out.print ' ', racc_token2str(t) }
      end
      out.puts " --> #{racc_token2str(sim)}"

      racc_print_stacks tstack, vstack
      @racc_debug_out.puts
    end

    def racc_accept
      @racc_debug_out.puts 'accept'
      @racc_debug_out.puts
    end

    def racc_e_pop( state, tstack, vstack )
      @racc_debug_out.puts 'error recovering mode: pop token'
      racc_print_states state
      racc_print_stacks tstack, vstack
      @racc_debug_out.puts
    end

    def racc_next_state( curstate, state )
      @racc_debug_out.puts  "goto    #{curstate}"
      racc_print_states state
      @racc_debug_out.puts
    end

    def racc_print_stacks( t, v )
      out = @racc_debug_out
      out.print '        ['
      t.each_index do |i|
        out.print ' (', racc_token2str(t[i]), ' ', v[i].inspect, ')'
      end
      out.puts ' ]'
    end

    def racc_print_states( s )
      out = @racc_debug_out
      out.print '        ['
      s.each {|st| out.print ' ', st }
      out.puts ' ]'
    end

    def racc_token2str( tok )
      type::Racc_token_to_s_table[tok] or
        raise RuntimeError, "[Racc Bug] can't convert token #{tok} to string"
    end

    def token_to_str( t )
      type::Racc_token_to_s_table[t]
    end

  end

end
..end /usr/local/ruby-1.6/lib/ruby/site_ruby/1.6/racc/parser.rb modeval..id5e8feb761f
end   # end of racc/parser.rb


class PD2Parser < ::Racc::Parser

module_eval <<'..end parsedate2.ry modeval..id99f03f36f1', 'parsedate2.ry', 177

  MONTHS = {
    'jan' => 1, 'feb' => 2, 'mar' => 3, 'apr' => 4,
    'may' => 5, 'jun' => 6, 'jul' => 7, 'aug' => 8,
    'sep' => 9, 'oct' =>10, 'nov' =>11, 'dec' =>12
  }
  MONTHPAT = MONTHS.keys.join('|')

  DAYS = {
    'sun' => 0, 'mon' => 1, 'tue' => 2, 'wed' => 3,
    'thu' => 4, 'fri' => 5, 'sat' => 6
  }
  DAYPAT = DAYS.keys.join('|')

  def next_token
    @str = @str.sub(/\A[\s\v]+/, '')
    return [false, false] if @str.size == 0

    if /\A(#{DAYPAT})[a-z]*\.?/ino =~ @str
      @str = $'
      return [:DAY, DAYS[$1.downcase]]
    end

    if /\A(\d+)(?:(?:th|st|nd|rd)\b)?/no =~ @str
      @str = $'
      return [:DIGITS, $1]
    end

    if /\A(#{MONTHPAT})[a-z]*\.?/ino =~ @str
      @str = $'
      return [:MON, MONTHS[$1.downcase]]
    end

    if /\A([ap])\.?m\.?\b/ino =~ @str
      @str = $'
      return [:MERID,
        if $1.downcase == 'a' then 0 else 12 end]
    end

    if /\A([a-z]+)/ino =~ @str
      @str = $'
      return [:LETTERS, $1]
    end

    if /\A(.)/no =~ @str
      @str = $'
      return [$1, $1]
    end
  end

  def clear() @values = {} end
  def store(key, val) @values[key] = val end
  def parse(str) @str = str; do_parse end

  def values(cyear)
    year = @values[:year]
    if cyear and year
      if year < 100
	if year >= 69
	  year += 1900
	else
	  year += 2000
	end
      end
    end
    @values[:year] = year
    @values.indexes(:year, :mon, :mday,
		    :hour, :min, :sec, :zone, :wday)
  end

..end parsedate2.ry modeval..id99f03f36f1

##### racc 1.3.8 generates ###

racc_reduce_table = [
 0, 0, :racc_error,
 0, 14, :_reduce_none,
 1, 14, :_reduce_none,
 2, 14, :_reduce_none,
 1, 17, :_reduce_none,
 3, 17, :_reduce_none,
 1, 17, :_reduce_none,
 5, 17, :_reduce_none,
 5, 17, :_reduce_none,
 5, 17, :_reduce_none,
 1, 17, :_reduce_none,
 3, 17, :_reduce_none,
 1, 17, :_reduce_none,
 3, 17, :_reduce_none,
 0, 16, :_reduce_none,
 2, 16, :_reduce_none,
 1, 15, :_reduce_16,
 0, 19, :_reduce_none,
 1, 19, :_reduce_none,
 1, 18, :_reduce_none,
 1, 18, :_reduce_none,
 2, 25, :_reduce_21,
 2, 26, :_reduce_22,
 1, 20, :_reduce_23,
 1, 22, :_reduce_none,
 1, 22, :_reduce_none,
 1, 22, :_reduce_none,
 1, 22, :_reduce_none,
 6, 27, :_reduce_28,
 7, 28, :_reduce_29,
 5, 29, :_reduce_30,
 3, 30, :_reduce_31,
 5, 30, :_reduce_32,
 3, 21, :_reduce_33,
 6, 21, :_reduce_34,
 0, 33, :_reduce_none,
 2, 33, :_reduce_36,
 2, 23, :_reduce_37,
 0, 31, :_reduce_none,
 1, 31, :_reduce_39,
 2, 24, :_reduce_40,
 0, 34, :_reduce_41,
 1, 34, :_reduce_none,
 0, 32, :_reduce_none,
 1, 32, :_reduce_none,
 1, 35, :_reduce_45,
 2, 35, :_reduce_46,
 2, 35, :_reduce_47,
 4, 35, :_reduce_48,
 1, 36, :_reduce_none,
 1, 36, :_reduce_none ]

racc_reduce_n = 51

racc_shift_n = 85

racc_action_table = [
    44,    45,    44,    45,    44,    45,    42,    -1,    42,     2,
    42,    26,    27,    28,    59,    23,    24,    25,    11,    13,
    -2,    17,    -6,    20,    39,    20,    20,   -17,    24,    25,
    20,   -17,    20,   -17,    24,    25,    50,    13,    20,   -17,
    47,    48,    51,    53,    55,    36,    35,    20,    58,    46,
    60,    62,    63,    64,    20,    26,    33,    66,    30,    51,
    69,    71,    72,    73,    75,    76,    77,    69,    79,    80,
    19,    28,    83,    28 ]

racc_action_check = [
    24,    24,    55,    55,    74,    74,    24,     0,    55,     0,
    74,    11,    11,    11,    43,    11,    11,    11,     1,     1,
     4,     1,    14,     4,    23,    14,    16,    16,    51,    51,
    18,    18,    37,    37,    36,    36,    31,    31,     8,     8,
    27,    27,    32,    33,    34,    22,    19,    38,    39,    25,
    45,    46,    47,    48,    49,    50,    17,    53,    13,    56,
    57,    58,    59,    61,    62,    63,    64,    65,    66,    72,
     3,    76,    79,    83 ]

racc_action_pointer = [
     7,    14,   nil,    70,    20,   nil,   nil,   nil,    35,   nil,
   nil,     6,   nil,    54,    22,   nil,    23,    52,    27,    46,
   nil,   nil,    41,    20,    -6,    45,   nil,    36,   nil,   nil,
   nil,    32,    38,    35,    40,   nil,    24,    29,    44,    39,
   nil,   nil,   nil,    10,   nil,    43,    40,    46,    47,    51,
    50,    18,   nil,    53,   nil,    -4,    55,    56,    57,    51,
   nil,    53,    60,    61,    62,    63,    60,   nil,   nil,   nil,
   nil,   nil,    65,   nil,    -2,   nil,    64,   nil,   nil,    68,
   nil,   nil,   nil,    66,   nil ]

racc_action_default = [
   -14,   -51,   -16,   -51,   -17,   -19,    -3,   -20,    -4,   -24,
   -25,   -38,   -26,   -51,   -17,   -27,   -10,   -51,   -12,   -51,
   -18,   -15,   -51,   -51,   -43,   -51,   -21,   -51,   -39,   -37,
   -22,   -51,   -51,   -51,   -51,    85,   -23,    -5,   -17,   -31,
   -33,   -44,   -50,   -51,   -49,   -45,   -35,   -51,   -51,   -17,
   -51,   -51,   -11,   -51,   -13,   -43,   -51,   -51,   -51,   -47,
   -46,   -41,   -51,   -51,   -51,   -51,   -51,   -40,    -9,   -23,
    -8,   -32,   -51,   -42,   -43,   -36,   -38,   -30,    -7,   -51,
   -48,   -34,   -28,   -38,   -29 ]

racc_goto_table = [
    29,    14,    40,    21,    37,     8,    18,    22,     6,    16,
     3,    54,     9,    31,    10,    32,    12,    34,    15,     1,
     4,    61,    38,    74,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,    52,    67,   nil,    49,    56,    57,   nil,    70,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,    78,    65,   nil,
   nil,   nil,    81,   nil,   nil,   nil,    68,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,    82,   nil,   nil,   nil,   nil,
   nil,   nil,    84 ]

racc_goto_check = [
    18,     8,    19,     6,     7,     5,    10,     6,     4,     9,
     1,    11,    14,     6,    15,     6,    16,     6,    17,     3,
     2,    20,     8,    21,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,     8,    19,   nil,     5,     6,     6,   nil,     7,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,     7,     6,   nil,
   nil,   nil,    19,   nil,   nil,   nil,     8,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,    18,   nil,   nil,   nil,   nil,
   nil,   nil,    18 ]

racc_goto_pointer = [
   nil,    10,    20,    19,     7,     4,    -1,   -18,     0,     8,
     5,   -23,   nil,   nil,    11,    13,    15,    17,   -11,   -22,
   -25,   -38,   nil,   nil ]

racc_goto_default = [
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,     5,     7,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,    41,    43 ]

racc_token_table = {
 false => 0,
 Object.new => 1,
 :DAY => 2,
 "," => 3,
 :DIGITS => 4,
 :MON => 5,
 "-" => 6,
 :LETTERS => 7,
 "." => 8,
 "/" => 9,
 :MERID => 10,
 ":" => 11,
 "+" => 12 }

racc_use_result_var = true

racc_nt_base = 13

Racc_arg = [
 racc_action_table,
 racc_action_check,
 racc_action_default,
 racc_action_pointer,
 racc_goto_table,
 racc_goto_check,
 racc_goto_default,
 racc_goto_pointer,
 racc_nt_base,
 racc_reduce_table,
 racc_token_table,
 racc_shift_n,
 racc_reduce_n,
 racc_use_result_var ]

Racc_token_to_s_table = [
'$end',
'error',
'DAY',
'","',
'DIGITS',
'MON',
'"-"',
'LETTERS',
'"."',
'"/"',
'MERID',
'":"',
'"+"',
'$start',
'repr',
'day',
'odaycom',
'dat',
'woy',
'ocom',
'year',
'time',
'wy',
'ddd',
'ttt',
'eu',
'us',
'iso',
'jis',
'vms',
'sla',
'otee',
'ozone',
'osec',
'omerid',
'zone',
'sign']

Racc_debug_parser = false

##### racc system variables end #####

 # reduce 0 omitted

 # reduce 1 omitted

 # reduce 2 omitted

 # reduce 3 omitted

 # reduce 4 omitted

 # reduce 5 omitted

 # reduce 6 omitted

 # reduce 7 omitted

 # reduce 8 omitted

 # reduce 9 omitted

 # reduce 10 omitted

 # reduce 11 omitted

 # reduce 12 omitted

 # reduce 13 omitted

 # reduce 14 omitted

 # reduce 15 omitted

module_eval <<'.,.,', 'parsedate2.ry', 25
  def _reduce_16( val, _values, result )
 store(:wday, val[0].to_i)
   result
  end
.,.,

 # reduce 17 omitted

 # reduce 18 omitted

 # reduce 19 omitted

 # reduce 20 omitted

module_eval <<'.,.,', 'parsedate2.ry', 31
  def _reduce_21( val, _values, result )
 store(:mday, val[0].to_i); store(:mon, val[1])
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 33
  def _reduce_22( val, _values, result )
 store(:mon, val[0]); store(:mday, val[1].to_i)
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 35
  def _reduce_23( val, _values, result )
 store(:year, val[0].to_i)
   result
  end
.,.,

 # reduce 24 omitted

 # reduce 25 omitted

 # reduce 26 omitted

 # reduce 27 omitted

module_eval <<'.,.,', 'parsedate2.ry', 41
  def _reduce_28( val, _values, result )
		  if val[4].size >= 4
		    store(:mday, val[0].to_i)
		    store(:mon,  val[2].to_i)
		    store(:year, val[4].to_i)
		  else
		    store(:year, val[0].to_i)
		    store(:mon,  val[2].to_i)
		    store(:mday, val[4].to_i)
		  end
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 55
  def _reduce_29( val, _values, result )
		  e = { 'M'=>1867,
			'T'=>1911,
			'S'=>1925,
			'H'=>1988
		      }[val[0]]
		  raise ParseError, 'YYERROR' unless e
		  store(:year, val[1].to_i + e)
		  store(:mon,  val[3].to_i)
		  store(:mday, val[5].to_i)
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 69
  def _reduce_30( val, _values, result )
		  if val[0].size >= 4
		    store(:year, val[0].to_i)
		    store(:mon,  val[2])
		    store(:mday, val[4].to_i)
		  else
		    store(:mday, val[0].to_i)
		    store(:mon,  val[2])
		    store(:year, val[4].to_i)
		  end
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 83
  def _reduce_31( val, _values, result )
		  store(:mon,  val[0].to_i)
		  store(:mday, val[2].to_i)
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 88
  def _reduce_32( val, _values, result )
		  if val[0].size >= 4
		    store(:year, val[0].to_i)
		    store(:mon,  val[2].to_i)
		    store(:mday, val[4].to_i)
		  else
		    store(:mon,  val[0].to_i)
		    store(:mday, val[2].to_i)
		    store(:year, val[4].to_i)
		  end
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 102
  def _reduce_33( val, _values, result )
		  store(:hour, val[0].to_i % 12 + val[1])
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 106
  def _reduce_34( val, _values, result )
		  hour = val[0].to_i
		  if val[4] != -1
		    hour = hour % 12 + val[4]
		  end
		  store(:hour, hour)
		  store(:min,  val[2].to_i)
   result
  end
.,.,

 # reduce 35 omitted

module_eval <<'.,.,', 'parsedate2.ry', 115
  def _reduce_36( val, _values, result )
 store(:sec, val[1].to_i)
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 119
  def _reduce_37( val, _values, result )
		  case val[0].size
		  when 4
		    store(:mon,  val[0][ 0, 2].to_i)
		    store(:mday, val[0][ 2, 2].to_i)
		  when 6
		    store(:year, val[0][ 0, 2].to_i)
		    store(:mon,  val[0][ 2, 2].to_i)
		    store(:mday, val[0][ 4, 2].to_i)
		  when 8, 10, 12, 14
		    store(:year, val[0][ 0, 4].to_i)
		    store(:mon,  val[0][ 4, 2].to_i)
		    store(:mday, val[0][ 6, 2].to_i)
		    store(:hour, val[0][ 8, 2].to_i) if val[0].size >= 10
		    store(:min,  val[0][10, 2].to_i) if val[0].size >= 12
		    store(:sec,  val[0][12, 2].to_i) if val[0].size >= 14
		  else
		    raise ParseError, 'YYERROR'
		  end
   result
  end
.,.,

 # reduce 38 omitted

module_eval <<'.,.,', 'parsedate2.ry', 140
  def _reduce_39( val, _values, result )
 raise ParseError, 'YYERROR' unless val[0] == 'T'
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 144
  def _reduce_40( val, _values, result )
		  case val[0].size
		  when 2, 4, 6
		    store(:hour, val[0][ 0, 2].to_i)
		    store(:min,  val[0][ 2, 2].to_i) if val[0].size >= 4
		    store(:sec,  val[0][ 4, 2].to_i) if val[0].size >= 6
		  else
		    raise ParseError, 'YYERROR'
		  end
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 155
  def _reduce_41( val, _values, result )
 result = -1
   result
  end
.,.,

 # reduce 42 omitted

 # reduce 43 omitted

 # reduce 44 omitted

module_eval <<'.,.,', 'parsedate2.ry', 159
  def _reduce_45( val, _values, result )
 store(:zone, val[0])
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 162
  def _reduce_46( val, _values, result )
		  raise ParseError, 'YYERROR' unless val[1] == 'DST'
		  store(:zone, val[0] + ' ' + val[1])
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 165
  def _reduce_47( val, _values, result )
 store(:zone, val[0] + val[1])
   result
  end
.,.,

module_eval <<'.,.,', 'parsedate2.ry', 166
  def _reduce_48( val, _values, result )
 store(:zone, val[0] + val[1] + val[2] + val[3])
   result
  end
.,.,

 # reduce 49 omitted

 # reduce 50 omitted

 def _reduce_none( val, _values, result )
  result
 end

end   # class PD2Parser


module ParseDate

  def parsedate(date, cyear=false)
    pa = PD2Parser.new
    pa.clear
    begin pa.parse(date); rescue; end
    pa.values(cyear)
  end

  module_function :parsedate

end
